#TEMPLATE (SecWin10, 'Datasoft Program Security for Windows 1.0')
#!=====================================================================
#EXTENSION (Activate_Security,'Activate SecWin features'),APPLICATION
#!----------------------
#DECLARE(%IncInPrj)
#SET(%IncInPrj,'SecWin10.Lib')
#PROJECT(%IncInPrj)
#!----------------------
#DISPLAY ()
#DISPLAY ('Enter the unique name of this Application.')
#DISPLAY ('You may use up to 20 characters and spaces are allowed.')
#DISPLAY ('Do NOT put the Version Number on this line')
#DISPLAY ()
#PROMPT  ('Unique Application Name :',@s20),%ApplicName
#!------------
#AT(%GlobalMap)
  include('SecMap10.Clw')
#ENDAT
#!---------
#GLOBALDATA
AppNameDesc  string(20)
AppNumQueue  Queue
AppNum         long
             .
#ENDGLOBALDATA
#!------------
#AT(%GlobalData)
  include ('SecEqu10.Clw')
#ENDAT
#!------------
#AT(%ProgramSetup)
  AppNameDesc = '%Applicname'
#ENDAT
#!=====================================================================
#EXTENSION (User_Login,'User Login here'),PROCEDURE
#!--------
#DISPLAY()
#DISPLAY('This function MUST exit through the ProcedureReturn')
#DISPLAY('routine for the "Logout" to work correctly.')
#DISPLAY()
#DISPLAY('Enter the name of the area this logon applies to.')
#DISPLAY('Note that the name of each logon area in the')
#DISPLAY('Application ( ie every time you get this screen )')
#DISPLAY('must be unique.')
#DISPLAY('The same name may be used in different applications.')
#DISPlAY('Spaces in the name are allowed')
#DISPLAY()
#PROMPT('Unique Area Name : ',@s20),%AreaName,REQ
#!------------------
#AT(%ProcedureInitialize)
LocalRequest = GlobalRequest      ! Save GlobalRequest
LocalResponse = RequestCancelled  ! In case the login fails
AppNum = ds_LogIn(Clip(AppNameDesc) & ' | %AreaName')
If AppNum = 0 then
  If Message('Access Denied','Security',Icon:Exclamation).
  get(AppNumQueue,1)
  #IF(%ProcedureType='FUNCTION')
  Return(%ReturnValue)
  #ELSE
  Return
  #ENDIF
.
Add(AppNumQueue,1)
GlobalRequest = LocalRequest  ! Restore GlobalRequest
#ENDAT
#!-----------
#AT(%EndOfProcedure)
If ds_LogOut(AppNum). ! throw away the value returned from Logout
Delete(AppNumQueue)
Get(AppNumQueue,1)
#ENDAT
#!=====================================================================
#EXTENSION (User_Screen_Security,'User Screen Security'),PROCEDURE
#!--------
#PROMPT ('Screen Name : ',@s21),%ScreenName
#DISPLAY()
#DISPLAY('Also Restrict :')
#DISPLAY('---------------')
#PROMPT ('1) Equate',CONTROL),%RestrictEqu1
#ENABLE (%RestrictEqu1)
#BUTTON ('Details of 1')
  #PROMPT ('Name',@s7), %RestrictNam1
  #PROMPT ('Action',DROP('Hide|Disable')),%RestrictAct1
  #PROMPT ('Equivalent equate',CONTROL),%RestrictEquiv1
#ENDBUTTON
#ENDENABLE
#PROMPT ('2) Equate',CONTROL),%RestrictEqu2
#ENABLE (%RestrictEqu2)
#BUTTON ('Details of 2')
  #PROMPT ('Name',@s7), %RestrictNam2
  #PROMPT ('Action',DROP('Hide|Disable')),%RestrictAct2
  #PROMPT ('Equivalent equate',CONTROL),%RestrictEquiv2
#ENDBUTTON
#ENDENABLE
#PROMPT ('3) Equate',CONTROL),%RestrictEqu3
#ENABLE (%RestrictEqu3)
#BUTTON ('Details of 3')
  #PROMPT ('Name',@s7), %RestrictNam3
  #PROMPT ('Action',DROP('Hide|Disable')),%RestrictAct3
  #PROMPT ('Equivalent equate',CONTROL),%RestrictEquiv3
#ENDBUTTON
#ENDENABLE
#PROMPT ('4) Equate',CONTROL),%RestrictEqu4
#ENABLE (%RestrictEqu4)
#BUTTON ('Details of 4')
  #PROMPT ('Name',@s7), %RestrictNam4
  #PROMPT ('Action',DROP('Hide|Disable')),%RestrictAct4
  #PROMPT ('Equivalent equate',CONTROL),%RestrictEquiv4
#ENDBUTTON
#ENDENABLE
#PROMPT ('5) Equate',CONTROL),%RestrictEqu5
#ENABLE (%RestrictEqu5)
#BUTTON ('Details of 5')
  #PROMPT ('Name',@s7), %RestrictNam5
  #PROMPT ('Action',DROP('Hide|Disable')),%RestrictAct5
  #PROMPT ('Equivalent equate',CONTROL),%RestrictEquiv5
#ENDBUTTON
#ENDENABLE
#PROMPT ('6) Equate',CONTROL),%RestrictEqu6
#ENABLE (%RestrictEqu6)
#BUTTON ('Details of 6')
  #PROMPT ('Name',@s7), %RestrictNam6
  #PROMPT ('Action',DROP('Hide|Disable')),%RestrictAct6
  #PROMPT ('Equivalent equate',CONTROL),%RestrictEquiv6
#ENDBUTTON
#ENDENABLE
#PROMPT ('7) Equate',CONTROL),%RestrictEqu7
#ENABLE (%RestrictEqu7)
#BUTTON ('Details of 7')
  #PROMPT ('Name',@s7), %RestrictNam7
  #PROMPT ('Action',DROP('Hide|Disable')),%RestrictAct7
  #PROMPT ('Equivalent equate',CONTROL),%RestrictEquiv7
#ENDBUTTON
#ENDENABLE
#!--------
#LOCALDATA
ThisAllowed        long    ! contains the users access rights
#ENDLOCALDATA
#!------------------
#AT(%ProcedureSetup)
! get and check users access rights to this function
#IF (%ScreenName)
ThisAllowed = ds_Allowed(AppNum,'%ScreenName',0)
#ELSE
ThisAllowed = ds_Allowed(AppNum,'%procedure',0)
#ENDIF
If ~Band(ThisAllowed,1)
  If Message('Your access to this part of the program has been restricted','Security',ICON:Exclamation).
  GlobalResponse = RequestCancelled
  #IF(%ProcedureType='FUNCTION')
  Return(%ReturnValue)
  #ELSE
  Return
  #ENDIF
.
#ENDAT
#!----------------
#AT(%BeforeAccept)
  Alert(DS_SECURITYKEY)
  #IF (%RestrictEqu1)
  If ~Band(ThisAllowed,2) then %RestrictAct1(%RestrictEqu1).
      #IF (%RestrictEquiv1)
  If ~Band(ThisAllowed,2) then %RestrictAct1(%RestrictEquiv1).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu2)
  If ~Band(ThisAllowed,4) then %RestrictAct2(%RestrictEqu2).
      #IF (%RestrictEquiv2)
  If ~Band(ThisAllowed,4) then %RestrictAct2(%RestrictEquiv2).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu3)
  If ~Band(ThisAllowed,8) then %RestrictAct3(%RestrictEqu3).
      #IF (%RestrictEquiv3)
  If ~Band(ThisAllowed,8) then %RestrictAct3(%RestrictEquiv3).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu4)
  If ~Band(ThisAllowed,16) then %RestrictAct4(%RestrictEqu4).
      #IF (%RestrictEquiv4)
  If ~Band(ThisAllowed,16) then %RestrictAct4(%RestrictEquiv4).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu5)
  If ~Band(ThisAllowed,32) then %RestrictAct5(%RestrictEqu5).
      #IF (%RestrictEquiv5)
  If ~Band(ThisAllowed,32) then %RestrictAct5(%RestrictEquiv5).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu6)
  If ~Band(ThisAllowed,64) then %RestrictAct6(%RestrictEqu6).
      #IF (%RestrictEquiv6)
  If ~Band(ThisAllowed,64) then %RestrictAct6(%RestrictEquiv6).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu7)
  If ~Band(ThisAllowed,128) then %RestrictAct7(%RestrictEqu7).
      #IF (%RestrictEquiv7)
  If ~Band(ThisAllowed,128) then %RestrictAct7(%RestrictEquiv7).
      #ENDIF
  #ENDIF
#ENDAT
#AT(%AcceptLoopAfterFieldHandling)
  #IF (%RestrictEqu1)
  If ~Band(ThisAllowed,2) then %RestrictAct1(%RestrictEqu1).
      #IF (%RestrictEquiv1)
  If ~Band(ThisAllowed,2) then %RestrictAct1(%RestrictEquiv1).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu2)
  If ~Band(ThisAllowed,4) then %RestrictAct2(%RestrictEqu2).
      #IF (%RestrictEquiv2)
  If ~Band(ThisAllowed,4) then %RestrictAct2(%RestrictEquiv2).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu3)
  If ~Band(ThisAllowed,8) then %RestrictAct3(%RestrictEqu3).
      #IF (%RestrictEquiv3)
  If ~Band(ThisAllowed,8) then %RestrictAct3(%RestrictEquiv3).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu4)
  If ~Band(ThisAllowed,16) then %RestrictAct4(%RestrictEqu4).
      #IF (%RestrictEquiv4)
  If ~Band(ThisAllowed,16) then %RestrictAct4(%RestrictEquiv4).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu5)
  If ~Band(ThisAllowed,32) then %RestrictAct5(%RestrictEqu5).
      #IF (%RestrictEquiv5)
  If ~Band(ThisAllowed,32) then %RestrictAct5(%RestrictEquiv5).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu6)
  If ~Band(ThisAllowed,64) then %RestrictAct6(%RestrictEqu6).
      #IF (%RestrictEquiv6)
  If ~Band(ThisAllowed,64) then %RestrictAct6(%RestrictEquiv6).
      #ENDIF
  #ENDIF
  #IF (%RestrictEqu7)
  If ~Band(ThisAllowed,128) then %RestrictAct7(%RestrictEqu7).
      #IF (%RestrictEquiv7)
  If ~Band(ThisAllowed,128) then %RestrictAct7(%RestrictEquiv7).
      #ENDIF
  #ENDIF
#ENDAT
#!---------------------------------
#AT(%WindowEventHandling),Where(%WindowEvent='GainFocus')
#IF (%ScreenName)
ThisAllowed = ds_Allowed(AppNum,'%ScreenName',0)
#ELSE
ThisAllowed = ds_Allowed(AppNum,'%procedure',0)
#ENDIF
#ENDAT
#!---------------------------------
#AT(%AcceptloopBeforeeventHandling)
  #DECLARE (%RestrictStr)
  #SET(%RestrictStr,'Access')
  #IF (%RestrictNam1)
    #SET(%RestrictStr,%RestrictStr & '|' & %RestrictNam1)
  #ENDIF
  #IF (%RestrictNam2)
    #SET(%RestrictStr,%RestrictStr & '|' & %RestrictNam2)
  #ENDIF
  #IF (%RestrictNam3)
    #SET(%RestrictStr,%RestrictStr & '|' & %RestrictNam3)
  #ENDIF
  #IF (%RestrictNam4)
    #SET(%RestrictStr,%RestrictStr & '|' & %RestrictNam4)
  #ENDIF
  #IF (%RestrictNam5)
    #SET(%RestrictStr,%RestrictStr & '|' & %RestrictNam5)
  #ENDIF
  #IF (%RestrictNam6)
    #SET(%RestrictStr,%RestrictStr & '|' & %RestrictNam6)
  #ENDIF
  #IF (%RestrictNam7)
    #SET(%RestrictStr,%RestrictStr & '|' & %RestrictNam7)
  #ENDIF
  If Event() = Event:AlertKey
    If KeyCode() = DS_SECURITYKEY
    #IF (%ScreenName)
      ds_SetAccess(AppNum,'%ScreenName','%RestrictStr')
    #ELSE
      ds_SetAccess(AppNum,'%Procedure','%RestrictStr')
    #ENDIF
      SetKeyCode(0)
  . .
#ENDAT
#!=====================================================================
#CODE (Call_OperatorBrowse,'Call SecWin''s Operator Browse function')
  ds_OperatorBrowse(AppNum)
#!=====================================================================
#CODE (Call_ChangePassword,'Call SecWin''s Change Password function')
  ds_ChangePassword(AppNum)
#!=====================================================================
#CODE (Call_ChangeLogin,'Call SecWin''s Change Login function')
  ds_ChangeLogin(AppNum)
#!=====================================================================
#CODE (Call_LockScreen,'Call SecWin''s Lock Screen function')
  ds_LockScreen(AppNum)
#!=====================================================================
#CODE (Call_Current,'Call SecWin''s Current User functions')
  #DISPLAY('This code template calls one of the ds_Current')
  #DISPLAY('functions and puts the result on your status bar.')
  #DISPLAY()
  #PROMPT('Position in status bar to use',@n2),%StatusPos
  #DISPLAY()
  #DISPLAY('Enter any text here that you want before the')
  #DISPLAY('current user.  Use quotes for literal text.')
  #PROMPT('Variables can also be used.',@s40),%UserPrompt
  #DISPLAY()
  #PROMPT('Call',OPTION),%CurrentCall
    #PROMPT('Current Name',RADIO) 
    #PROMPT('Current Login',RADIO)
    #PROMPT('Current Level',RADIO)
  #IF (%CurrentCall = 'Current Level')
  IF ds_CurrentLevel(AppNum) = DS_SUPERVISOR
    %Window{prop:statustext,%StatusPos} = %UserPrompt & 'Supervisor'
  ELSE
    %Window{prop:statustext,%StatusPos} = %UserPrompt & 'Operator'
  .
  #ELSIF (%CurrentCall = 'Current Login')
  %Window{prop:statustext,%StatusPos} = %UserPrompt & ds_CurrentLogin(AppNum)
  #ELSE 
  %Window{prop:statustext,%StatusPos} = %UserPrompt & ds_CurrentName(AppNum)
  #ENDIF
