/* @(#)FrIJDEMainFrame.java  1.00  2/21/96  Benjamin "Quincy" Cabell V (thethe@wpi.edu), Besiex Software.
 * 
 * Copyright (c) 1996 Besiex Software. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that credit is this copyright notice
 * appears in all copies.  
 *
 * Distributed under the terms of the GNU Library General Public License.
 * 
 * FrIJDE Homepage:
 * http://amber.wpi.edu/~thethe/Document/Besiex/Java/FrIJDE/
 */

package besiex.FrIJDE.AbstractClasses;

import java.awt.*;

/**
This is the class that the interpreted (executable) class extends. <p>


@version 1.00,  21 February 1996

<p>

<b>Changes from last version</b>

<ul>
 	<li> No last version.
</ul>
 
@author <A HREF="http://amber.wpi.edu/~thethe">Benjamin "Quincy" Cabell V</A>
@author <A HREF="http://amber.wpi.edu/~thethe/Documents/Besiex/Java/index.html">Besiex Software</A>
*/

public abstract class FrIJDEMainFrame extends Frame {
	/**
	The path to the base FrIJDE directory.  This is the directory in which the FrIJDEMainFrame extended interpretable code should be
	located.  This directory includes the directories System, Tools, and AbstractClasses. <p>
	*/

	public String baseDir = null;

	/**
	The handle to the instance of the FrIJDEToolLoader. <p>
	*/

	public FrIJDEToolLoader toolLoader=null;


	/**
	The constructor which sets the FrIJDEMainFrame's frame title to "FrIJDE". <p>
	*/
	
	public FrIJDEMainFrame() {
		super("FrIJDE");
	}


	/**
	Closes FrIJDE by requesting the closing of the FrIJDEToolLoader (which requests the closing of all the FrIJDETools).
	If the FrIJDEToolLoader reports that it can close, FrIJDE exits. <p>
	
	*@return True if it closes, false otherwise.  (If System.exit(int) is used, the return value is somewhat meaningless.)
	*/

	public boolean Close () {
		if (toolLoader.Close()) {

			System.exit(0);
			return true;
		}
		return false;
	}


        
	/**
	The file name and path of the document manager's most recently focused editor file. <p>
	*/
	
	public String currentEditorFile=null;

	/**
	Sets the FrIJDEMainFrame's value for what it believes is the file name and path of the document manager's 
	most recently focused editor file.  This method should ONLY be called by the document manager when it changes
	document focus. <p>
	*/

	public void SetCurrentEditorFile(String theFileNameWithPath) {
		currentEditorFile = theFileNameWithPath;
	}

	/**
	Gets FrIJDEMainFrame's value for what it believes is the file name and path of the document manager's 
	most recently focused editor file.  This is of particular importance to tools which direct their action at the 
	currentEditorFile. <p>

	*@return The file name and path of the document manager's most recently focused editor file.
	*/

	public String GetCurrentEditorFile () {
		return currentEditorFile;
	}


	/**
	Handles the request to close, otherwise passes the event to the over-ridden handleEvent(Event). <p>
	
	*@return True if the event is handled and need not be passed along the chain of handlers, false otherwise.
	*/

	public boolean handleEvent(Event e) {

		if (e.id == Event.WINDOW_DESTROY) {
			if (Close()) {
				return true;
			} else
				return true;
		} else 

		return super.handleEvent(e);
	}


	public static void main (String args[]) { }

}
