/* @(#)FrIJDETool.java  1.00  2/21/96  Benjamin "Quincy" Cabell V (thethe@wpi.edu), Besiex Software.
 * 
 * Copyright (c) 1996 Besiex Software. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that credit is this copyright notice
 * appears in all copies.  
 *
 * Distributed under the terms of the GNU Library General Public License.
 * 
 * FrIJDE Homepage:
 * http://amber.wpi.edu/~thethe/Document/Besiex/Java/FrIJDE/
 */

package besiex.FrIJDE.AbstractClasses;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

/**
 All FrIJDETools are extended from this class.  This class defines all the most basic requirements of a FrIJDETool.
<p>


@version 1.00,  21 February 1996

<p>

<b>Changes from last version</b>

<ul>
 	<li> No last version.
</ul>
 
@author <A HREF="http://amber.wpi.edu/~thethe">Benjamin "Quincy" Cabell V</A>
@author <A HREF="http://amber.wpi.edu/~thethe/Documents/Besiex/Java/index.html">Besiex Software</A>
*/

public abstract class FrIJDETool {


		/**
		A handle to the FrIJDEMainFrame.
		*/
		
		public FrIJDEMainFrame frijdeMainFrame = null;


		/**
		The FrIJDEToolLoader will need to be be able to set the FrIJDEMainFrame handle once each tool
		is instantiated. Setting the FrIJDEMainFrame is done through this method. <p>

		*@param theMainFrame The handle this tool will set as the FrIJDEMainFrame handle.
		*/

		public void SetFrIJDEMainFrame(FrIJDEMainFrame theMainFrame) {
			frijdeMainFrame = theMainFrame;
		}


		/**
		FrIJDETools will often have supporting classes.  Many of these supporting classes may need to be able
		to get a handle to the FrIJDEMainFrame.  These supporting classes can use this method for that purpose. <p>

		*@param theMainFrame The handle this tool will set as the FrIJDEMainFrame handle.
		*@return The handle to the FrIJDEMainFrame.
		*/


		public FrIJDEMainFrame GetFrIJDEMainFrame () {
			return (frijdeMainFrame);
		}


		/**
		Once a FrIJDETool is instantiated, it must be initialized via this method.  This method returns true if the 
		initialization was usuccessful, false otherwise. <p>
		

		*@param theFrIJDEMainFrame The handle this tool will set as the FrIJDEMainFrame handle.
		*@return The handle to the FrIJDEMainFrame.
		*/

		public boolean Init(FrIJDEMainFrame theFrIJDEMainFrame) {
			SetFrIJDEMainFrame(theFrIJDEMainFrame);
			return true;
		}


		/**
		The MenuItem to be added to the FrIJDEMainFrame Help menu (the menu item must be able to handle 
		its selection via some form of callback mechanism, such as the
		<a href="http://www.panix.com/~rangerx/packages.html">awtExt and sysExt Package</a>). <p>
		*/

		public MenuItem helpMenuItem = null;


		/**
		The MenuItem to be added to the FrIJDEMainFrame Preferences menu (the menu item must be able to handle 
		its selection via some form of callback mechanism, such as the
		<a href="http://www.panix.com/~rangerx/packages.html">awtExt and sysExt Package</a>). <p>
		*/

		public MenuItem preferencesMenuItem = null;


		/**
		The MenuItem to be added to the FrIJDEMainFrame Tools menu (the menu item must be able to handle 
		its selection via some form of callback mechanism, such as the
		<a href="http://www.panix.com/~rangerx/packages.html">awtExt and sysExt Package</a>). <p>
		*/

		public MenuItem toolMenuItem = null;


		/**
		The MenuItem to be added to the FrIJDEMainFrame About menu (the menu item must be able to handle 
		its selection via some form of callback mechanism, such as the
		<a href="http://www.panix.com/~rangerx/packages.html">awtExt and sysExt Package</a>). <p>
		*/

		public MenuItem aboutMenuItem = null; 


		/**
		A FrIJDETool can request that it have additional Menus placed on the FrIJDEMainFrame MenuBar.  These Menus
		are stored in this array where they will be included by the FrIJDEToolLoader.  Each Menu and its MenuItems
		must handle their selection via some form of callback mechanism, such as the
		<a href="http://www.panix.com/~rangerx/packages.html">awtExt and sysExt Package</a>). <p>
		*/

		public Menu[] menusOnMainMenuBar = null;


		/**
		A FrIJDETool can request that it have Components placed on the FrIJDEMainFrame FrIJDEBasicToolBar.  These Components
		are stored in this array where they will be included by the FrIJDEToolLoader.  Each Component
		must handle its selection via some form of callback mechanism, such as the
		<a href="http://www.panix.com/~rangerx/packages.html">awtExt and sysExt Package</a>).
		The <a href="http://amber.wpi.edu/~thethe/Documents/Besiex/Java/">MightyButtonWithCallback</a> can
		be used to create tool bar buttons. <p>
		*/

		public Component[] toolBarButtons = null;


   		/**
		When the FrIJDEMainFrame receives a request to exit it must check with all of the loaded tools.  
		Each tool has the opportunity save/close open files/settings or exit threads, etc.  If this method returns
		true then the FrIJDEMainFrame is free to close, otherwise it should not. <p>

		*@return True if it is safe for the FrIJDEMainFrame to close (according to this tool).  False otherwise.
		*/

   
		public abstract boolean Close();     
}
