/* @(#)FrIJDEToolLoader.java  1.03  2/27/96  Benjamin "Quincy" Cabell V (thethe@wpi.edu), Besiex Software.
 * 
 * Copyright (c) 1996 Besiex Software. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that credit is this copyright notice
 * appears in all copies.  
 *
 * Distributed under the terms of the GNU Library General Public License.
 * 
 * FrIJDE Homepage:
 * http://amber.wpi.edu/~thethe/Document/Besiex/Java/FrIJDE/
 */

package besiex.FrIJDE.AbstractClasses;

import java.awt.Frame;

/**
This is the class that the tool loader must extend.  This class defines the basic requirements of the tool loader
as defined by the FrIJDEMainFrame and the FrIJDETools.  The tool loader must load only one document manager and
one project manager.  If multiple document or project managers exist within the Tools directory, the tool loader 
must make the decision as to which one(s) should be loaded (this should, of course, be chosen based upon the 
preferences of the user). <p>


@version 1.03,  27 February 1996

<p>

<b>Changes from last version</b>

<ul>
 	<li> Tool loader is now expected to keep a handle to the document manager and project manager.
</ul>
 
@author <A HREF="http://amber.wpi.edu/~thethe">Benjamin "Quincy" Cabell V</A>
@author <A HREF="http://amber.wpi.edu/~thethe/Documents/Besiex/Java/index.html">Besiex Software</A>
*/

public abstract class FrIJDEToolLoader extends FrIJDETool {

	public FrIJDEToolLoader () {	
	}

	/**
	FrIJDEMainFrame requires the tool loader to provide it with the menu bar it is going to use as the
	main FrIJDE menu bar. <p>

	*@return The menu bar that FrIJDEMainFrame will use as the main menu bar.
	*/

	public abstract java.awt.MenuBar GetMenuBar ();


	/**
	FrIJDEMainFrame requires the tool loader to provide it with the tool bar it is going to display. <p>

	*@return The tool bar that FrIJDEMainFrame will display.
	*/

	public abstract FrIJDEBasicToolBar GetToolBar ();


	/**
	This is used to store the handle to the loaded FrIJDEDocumentManager.
	*/

	protected FrIJDEDocumentManager frijdeDocumentManager=null;

	/**
	FrIJDETools may need access to the FrIJDEDocumentManager in order to send the editor to a particular line
	of code.  This may be done through this method.  Setting the FrIJDEDocumentManager is done within the FrIJDEToolLoader. <p>

	*@return The FrIJDEDocumentManager loaded.
	*/

	public FrIJDEDocumentManager GetFrIJDEDocumentManager () {
		return frijdeDocumentManager;
	}
}

