/* @(#)FrIJDEMain.java  1.09  2/25/96  Benjamin "Quincy" Cabell V (thethe@wpi.edu), Besiex Software.
 * 
 * Copyright (c) 1996 Besiex Software. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that credit is this copyright notice
 * appears in all copies.  
 *
 * Distributed under the terms of the GNU Library General Public License.
 * 
 * FrIJDE Homepage:
 * http://amber.wpi.edu/~thethe/Document/Besiex/Java/FrIJDE/
 */

import java.awt.*;
import java.lang.*;
import java.io.*;

import besiex.FrIJDE.AbstractClasses.*;
import besiex.FrIJDE.Tools.*;
import besiex.FrIJDE.System.*;

public class FrIJDEMain extends FrIJDEMainFrame {
    
	public final static String iniFileName = "FrIJDE.ini";
	public final static String pathToIniFile = "./System/";

	Class toolLoaderClass=null;
	String toolLoaderClassName;

	public FrIJDEMain() {
		baseDir = FrIJDEStringMethods.GetKeyValueFromINIFile (pathToIniFile+iniFileName,"FrIJDE System","Program root directory");
		toolLoaderClassName = FrIJDEStringMethods.GetKeyValueFromINIFile (pathToIniFile+iniFileName,"FrIJDE System","Tool loader");

		try {
			toolLoaderClass = Class.forName(toolLoaderClassName);
		} catch (Exception e) {
			System.out.println("FrIJDEMain:: -- Fatal error.  Tool loader specified in 'FrIJDE.ini' not found, or something.");
			System.exit(1);
		}

//		System.out.println(toolLoaderClass);

		try {
			toolLoader = (FrIJDEToolLoader) toolLoaderClass.newInstance();
		} catch (Exception e) {
			System.out.println("FrIJDEMain:: -- Fatal error.  Could not instantiate '"+toolLoaderClassName+"', the FrIJDEToolLoader specified in 'FrIJDE.ini'.");
			System.out.println(e);
			System.exit(1);
		}
    
//		System.out.println("ToolLoader this="+toolLoader);

		toolLoader.Init(this);

		// Install the menu bar
		MenuBar menuBar = toolLoader.GetMenuBar();
//		System.out.println("MenuBar: "+menuBar);
		setMenuBar(menuBar);
                
		// Brings up the tool bar
		toolLoader.GetToolBar();

		resize(500,350);
		show();
      }


	public static void main (String args[]) {
		FrIJDEMain I = new FrIJDEMain();
	}
}
