package awtExt ;
/*
 * @(#)Frame.java	1.0 96/01/05  Sal Cataudella
 *
 * Copyright (c) 1995 Sal Cataudella. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please contact author for other arrangements.
 *
 *
 */



import java.awt.Event;

/**
* Extension of standard awt Frame. Provides a callback
* mechanism for invoking user defined event handling methods.
* A callback method can be attached on each and every event 'hook'
* in the Frame's eventDispatch object. 
* @see		awtExt.EventDispatch
* @see		awtExt.Callback
* @see		java.awt.Event
* @see		java.awt.Frame
* @author		Sal Cataudella
* @version        1.0     Jan 05 1996
**/
public class Frame extends java.awt.Frame {
	/**
	* Event dispatcher. Dispatches the event to the appropriate
	*  user defined method.
	* @see	awt.Event
	* @see	awtExt.EventDispatch
	* @see	awtExt.Callback
	* 
	**/
	public EventDispatch eventDispatch = new EventDispatch( this ) ;

	/**
	* Default Constructor. 
	**/
	public Frame(){
		super( ) ;
	}

	/**
	* Constructor. Takes a string as a parameter, to be
	* used as the frame's title.
	* @param aTitle Title for the frame
	**/
	public Frame( java.lang.String aTitle){
		super( aTitle) ;
	}	

	/**
	* event handler. Dispatches the event to the appropriate
	* attached methodRef event handler . User defined method(s) can control
	* the event propagation by setting the 'processed' instance variable
	* in the CallbackInfo object.
	* @param	evt The event.
	* @see	awt.Event
	* @see	awtExt.EventDispatch
	* @see	awtExt.CallbackInfo#processed
	*
	**/
      public final boolean handleEvent(java.awt.Event evt) {
		return eventDispatch.handle( evt );
	}

} ;

