package awtExt ;


/*
 * @(#)TextField.java	1.0 96/01/05  Sal Cataudella
 *
 * Copyright (c) 1995 Sal Cataudella. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please contact author for other arrangements.
 *
 *
 */

import sysExt.* ;

/**
* Extension of standard awt TextArea. Provides a callback
* mechanism for invoking user defined event handling methods.
* A callback method can be attached on each and every event 'hook'
* in the TextArea's eventDispatch object. 
* @see		awtExt.EventDispatch
* @see		awtExt.Callback
* @see		java.awt.Event
* @see		java.awt.TextArea
* @author		Sal Cataudella
* @version        1.0     Jan 05 1996
**/

public class TextArea extends java.awt.TextArea {

	/**
	* Event dispatcher. Dispatches the event to the appropriate
	* user defined event handling method.
	* @see	java.awt.Event
	* @see	awtExt.EventDispatch
	* @see	awtExt.Callback
	* 
	**/
	public EventDispatch eventDispatch = new EventDispatch( this ) ;

	/**
	* Default Constructor. 
	**/
	public TextArea() {
		super( ) ;
	}

	/**
	* Constructor, creates a textarea with nRows rows and nColumns colums.
	* @param nRows Number of rows for this textfield
	* @param nColumns Number of columns for this textfield
	**/	
	public TextArea( int nRows, int nColumns ) {
		super( nRows, nColumns ) ;
	}

	/**
	* Constructor, creates a textarea initialized to aValue string.
	* @param aValue String to initialize text area with.
	**/	
	public TextArea( java.lang.String aValue  ) {
		super( aValue ) ;
	}

	/**
	* Constructor, creates a textarea initialized to aValue string
	* with numColumns columns..
	* @param aValue String to initialize area with.
	* @param nRows Number of rows for this textarea
	* @param nColumns Number of columns for this textarea
	**/	
	public TextArea( java.lang.String aValue, int nRows, int nColumns) {
		super( aValue, nRows, nColumns ) ;
	}	

	/**
	* Event handler. Dispatches the event to the appropriate
	* attached methodRef. User defined method(s) can control
	* the event propagation by setting the processed instance variable
	* in the CallbackInfo object.
	* @param	evt The event.
	* @see	awt.Event
	* @see	awtExt.EventDispatch#handle
	* @see	awtExt.CallbackInfo#processed
	*
	**/
      public boolean handleEvent(java.awt.Event evt) {
		return eventDispatch.handle( evt ) ;
      }
} ;

