package sysExt ;
/*
 * @(#)CodeAttr.java	1.0 96/01/05  Sal Cataudella
 *
 * Copyright (c) 1995 Sal Cataudella. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please contact author for other arrangements.
 *
 *
 */
import java.io.IOException;
import java.io.DataOutputStream;


//-------------------------------------------------------
// Code Attr - Attribute of a method. Currently only
// this attribute is supported...
//
class CodeAttr extends Object {
	
	short	attributeNameIndex ;
	int	attributeLength = 0;
	short	maxStack = 1;
	short	maxLocals = 1;
	int	codeLength ;
	byte	code[] ;
	short	exceptionTableLength = 0 ; //no exception tbl for now...
	short	attributesCount = 1;
	LineAttr attributes[] ;

	static final int baseSize = 25;

	CodeAttr (	ConstStringInfo codeString,
			int  byteCodeLength,
			byte byteCodes[],
			LineAttr lineAttr, int  mStack, int mLocals ) {

		attributeNameIndex = codeString.index ;
		codeLength = (short)byteCodeLength;
		code = byteCodes ;
		attributes = new LineAttr[1] ;
		attributes[0] = lineAttr ;

		attributeLength = 12 + codeLength + lineAttr.size() ;
		maxStack = (short)mStack ;
		maxLocals = (short)mLocals ;
	}


	void write( DataOutputStream out ) throws IOException {
		out.writeShort( attributeNameIndex );
		out.writeInt( attributeLength );
		out.writeShort( maxStack );
		out.writeShort( maxLocals ) ;
		out.writeInt( codeLength ) ;
		out.write( code, 0, codeLength ) ;
		out.writeShort( exceptionTableLength ) ;
		out.writeShort( attributesCount ) ;
		attributes[0].write( out ) ;

	}	

} ;
