package sysExt ;
/*
 * @(#)LineAttr.java	1.0 96/01/05  Sal Cataudella
 *
 * Copyright (c) 1995 Sal Cataudella. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please contact author for other arrangements.
 *
 *
 */
import java.io.IOException;
import java.io.DataOutputStream;


//------------------------------------------------------
// LineAttr - Used by debugger to correlate VM code location
// to source code...
//
class LineAttr extends Object {

	short	attributeNameIndex;
	short	attributeLength = 0;
	short	lineNumberTableLength;
	byte	lineNumberTable[];

	LineAttr(	ConstStringInfo attributeName, 
			int initLineListLength,
			byte initLineList[]) {

		this.attributeNameIndex = attributeName.index ;
		this.lineNumberTableLength = (short)initLineListLength ;
		this.lineNumberTable = initLineList ;
	}

	
	void write( DataOutputStream out ) throws IOException {
		out.writeShort( attributeNameIndex ) ;
		out.writeShort( attributeLength ) ;
		out.writeShort( lineNumberTableLength ) ;
		out.write( lineNumberTable, 0, lineNumberTableLength ) ;
	
	}

	int size() {
		return 6 + lineNumberTableLength ;	
	}
}
