package sysExt ; 
/*
 * @(#)MethodInfo.java	1.0 96/01/05  Sal Cataudella
 *
 * Copyright (c) 1995 Sal Cataudella. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please contact author for other arrangements.
 *
 *
 */
import java.io.IOException;
import java.io.DataOutputStream;



/*----------------
* java method info
*/
class MethodInfo implements RuntimeConstants {
	short   accessFlags = (short)ACC_PUBLIC ;
	short   nameIndex ;
	short	signatureIndex ;
	short	attributeCount = 1;
	CodeAttr attrib[] = new CodeAttr[ attributeCount ] ;

	MethodInfo ( ConstStringInfo nameString,
			ConstStringInfo sigString,
			CodeAttr	codeAttr ) {

		nameIndex = nameString.index ;
		signatureIndex = sigString.index ;
		attrib[0] = codeAttr ;
	}

	void write( DataOutputStream out ) throws IOException {
		out.writeShort(accessFlags );
		out.writeShort(nameIndex );
		out.writeShort(signatureIndex );
		out.writeShort(attributeCount) ;

		attrib[0].write( out ) ;
	}
	

};

