/* @(#)FrIJDEStringMethods.java  1.09  2/25/96  Benjamin "Quincy" Cabell V (thethe@wpi.edu), Besiex Software.
 * 
 * Copyright (c) 1996 Besiex Software. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that credit is this copyright notice
 * appears in all copies.  
 *
 * Distributed under the terms of the GNU Library General Public License.
 * 
 * FrIJDE Homepage:
 * http://amber.wpi.edu/~thethe/Document/Besiex/Java/FrIJDE/
 */

package besiex.FrIJDE.System;

import java.lang.*;
import java.awt.*;
import java.io.*;

public class FrIJDEStringMethods {


	public static String FilePathFromFileNameWithPath (String theFileNameWithPath) {
		int posOfSep = theFileNameWithPath.lastIndexOf(java.io.File.separator);

		if (posOfSep != -1)
			theFileNameWithPath = theFileNameWithPath.substring(0,posOfSep);

		return (theFileNameWithPath);
	}


	public static String FileNameFromFileNameWithPath (String theFileNameWithPath) {
		int posOfSep = theFileNameWithPath.lastIndexOf(java.io.File.separator);

		if (posOfSep != -1)
			theFileNameWithPath = theFileNameWithPath.substring(posOfSep+1);

		return (theFileNameWithPath);
	}


	public static String GetKeyValueFromINIFile (String theINIFileName,String theSectionName,String theKeyName) {
		
		// Load the INI file into a String
		String iniFileAsString = FileToString(theINIFileName);
		
		// Get the section
		String sectionAsString = GetINISection (iniFileAsString,theSectionName);

		// Get the key value
		String keyValueAsString = GetINIKeyValue (sectionAsString,theKeyName);

		return (keyValueAsString);
	}


	
	public static String GetINIKeyValue(String theSectionName,String theKeyName) {

		// Get the key (and all that follows)
		String keyValue = theSectionName.substring(theSectionName.indexOf(theKeyName+"="));

		// Trim the "KEYNAME="
		keyValue = keyValue.substring(keyValue.indexOf("=")+1);

		// Trim any following keys
		int indexOfEndOfLine = keyValue.indexOf("\r");

		if (indexOfEndOfLine == -1) 
			indexOfEndOfLine = keyValue.indexOf("\n");

		if (indexOfEndOfLine != -1) {
			keyValue = keyValue.substring(0,indexOfEndOfLine);
		}

		return keyValue.trim();
	}

	
	
	
	
	public static String GetINISection(String theINIFileAsString,String theSectionName) {

		// Get the section (and all that follows)
		String sectionAsString = theINIFileAsString.substring(theINIFileAsString.indexOf("["+theSectionName+"]"));

		// Trim the heading
		sectionAsString = sectionAsString.substring(sectionAsString.indexOf("]")+1);

		// Trim any section that follows this one
		int indexOfFollowingSection = sectionAsString.indexOf("[");

		if (indexOfFollowingSection == -1)
			return sectionAsString;
		
		sectionAsString = sectionAsString.substring(0,indexOfFollowingSection);
		return sectionAsString;
	}



	public static String FileToString (String theFileName) {
		
		FileInputStream fileIn = null;
		
		try {
			fileIn = new FileInputStream(new File(theFileName));
		} catch (Exception e) {
			System.out.println("Error! Probably couldn't find INI file specified.");
			System.out.println(e);
			return null;
		}

		String fileAsString = new String();

		int readByte=-1;
		char byteAsChar;

		do {
			try {
				readByte = fileIn.read();
			} catch (Exception e) {
				System.out.println ("Error reading!");
			}
			
			if (readByte == -1)
				return fileAsString;

			fileAsString = fileAsString.concat(new Character((char) readByte).toString());
		} while (true);
	}
}
