/* @(#)FrIJDEToolLoader.java  1.07  2/27/96  Benjamin "Quincy" Cabell V (thethe@wpi.edu), Besiex Software.
 * 
 * Copyright (c) 1996 Besiex Software. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that credit is this copyright notice
 * appears in all copies.  
 *
 * Distributed under the terms of the GNU Library General Public License.
 * 
 * FrIJDE Homepage:
 * http://amber.wpi.edu/~thethe/Document/Besiex/Java/FrIJDE/
 */

package besiex.FrIJDE.System;

import java.lang.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import besiex.FrIJDE.AbstractClasses.*;
import besiex.FrIJDE.Tools.*;

public class FrIJDEToolLoaderAlpha extends besiex.FrIJDE.AbstractClasses.FrIJDEToolLoader {

	String baseDir;
	String toolDir;
	Vector tools;

	Menu helpMenu = new Menu("Help");
	Menu preferencesMenu = new Menu("Preferences...");
	Menu toolsMenu = new Menu("Tools");
	Menu aboutMenu = new Menu("About...");
	MenuBar mainMenuBar = new MenuBar();

	int toolButtonsInstalled = 0;

	FrIJDEBasicToolBar toolBar = null;
	
	public FrIJDEToolLoaderAlpha () {
//		System.out.println("About to load tools...");

		baseDir = FrIJDEStringMethods.GetKeyValueFromINIFile ("./System/FrIJDE.ini","FrIJDE System","Program root directory");
//		System.out.println("BaseDir: "+baseDir);
		
		toolDir = baseDir.concat("Tools/");
		
//		System.out.println ("FrIJDEToolLoaderAlpha:: -- End");
	}



	public boolean Init(FrIJDEMainFrame theFrIJDEFrame) {
		SetFrIJDEMainFrame (theFrIJDEFrame);
		
		String toolNames[] = GetToolNames();
		
		tools = new Vector(toolNames.length);
		
		Class toolClass=null;
		FrIJDETool toolInstantiation=null;

		Vector tempExtraMenus = new Vector(5);

		for (int i=0;i < toolNames.length;i++) {
			System.out.println("Loading tool ("+toolNames[i]+")...");


			try {
				toolClass = Class.forName(toolNames[i]);
			} catch (Exception e) {
				System.out.println("FrIJDEMain:: -- Fatal error.  Tool loader could not load "+toolNames[i]);
				System.out.println(e);
				System.exit(1);
			}			

			try {
				toolInstantiation = (FrIJDETool) toolClass.newInstance();
			} catch (Exception e) {
				System.out.println("FrIJDEMain:: -- Fatal error.  Could not instantiate the FrIJDETool "+toolNames[i]);
				System.out.println(e);
				System.exit(1);
			}

			toolInstantiation.Init(GetFrIJDEMainFrame());
			tools.addElement(toolInstantiation);

			if (toolInstantiation instanceof FrIJDEDocumentManager)
				frijdeDocumentManager = (FrIJDEDocumentManager) toolInstantiation;

//			System.out.println("Creating basic menus");
			
			if (toolInstantiation.helpMenuItem != null)
				helpMenu.add(toolInstantiation.helpMenuItem);

			if (toolInstantiation.preferencesMenuItem != null)
				preferencesMenu.add(toolInstantiation.preferencesMenuItem);
			
			if (toolInstantiation.toolMenuItem != null)
				toolsMenu.add(toolInstantiation.toolMenuItem);
			
			if (toolInstantiation.aboutMenuItem != null)
				aboutMenu.add(toolInstantiation.aboutMenuItem);

//			System.out.println("Finding menus to add to main menu bar");

			if (toolInstantiation.menusOnMainMenuBar != null) 
				if (toolInstantiation.menusOnMainMenuBar.length > 0) {
					for (int j=0;j < toolInstantiation.menusOnMainMenuBar.length;j++) {
						tempExtraMenus.addElement(toolInstantiation.menusOnMainMenuBar[j]);
					}
				}

//			System.out.println("Finding buttons to put on toolbar");
			
			if (toolInstantiation.toolBarButtons != null) {
				String toolAddString = null;

				if (toolBar == null) {
					toolBar = new FrIJDEAlphaToolBar(GetFrIJDEMainFrame());
				}
				
				if (toolInstantiation.toolBarButtons.length > 0) {
					for (int j=0;j < toolInstantiation.toolBarButtons.length;j++) {
						toolButtonsInstalled++;
						if (toolButtonsInstalled == 1)
							toolAddString = "toolButton"+toolButtonsInstalled+";relative to=none;placement=base";
						else
							toolAddString = "toolButton"+toolButtonsInstalled+";relative to=toolButton"+(toolButtonsInstalled-1)+";placement=right";
						toolBar.toolBar.add(toolAddString,toolInstantiation.toolBarButtons[j]);
//						System.out.println("adding tool to layout "+toolButtonsInstalled);
					}
				}
			}

		}

//		System.out.println ("Making menu bar.");

		// The *Main* menu bar can now be built...

		// The basic order should be:
		//
		//  File Edit Tool <extra menus go here> Preferences Help
		//                                                      + About
		//
		//                 

		// Scan through the temp extra menus to find one named "File".  This goes first.

		for (int i=0;i < tempExtraMenus.size();i++) {
			if (((Menu) tempExtraMenus.elementAt(i)).getLabel().equals ("File")) {
				// Found the "File" menu
				mainMenuBar.add((Menu) tempExtraMenus.elementAt(i));
				tempExtraMenus.removeElementAt(i);
				break;
			}
		}

		// Scan through the temp extra menus to find one named "Edit".  This goes second.

		for (int i=0;i < tempExtraMenus.size();i++) {
			if (((Menu) tempExtraMenus.elementAt(i)).getLabel().equals ("Edit")) {
				// Found the "Edit" menu
				mainMenuBar.add((Menu) tempExtraMenus.elementAt(i));
				tempExtraMenus.removeElementAt(i);
				break;
			}
		}

		// Scan through the temp extra menus to find one named "Project".  This goes third.

		for (int i=0;i < tempExtraMenus.size();i++) {
			if (((Menu) tempExtraMenus.elementAt(i)).getLabel().equals ("Edit")) {
				// Found the "Edit" menu
				mainMenuBar.add((Menu) tempExtraMenus.elementAt(i));
				tempExtraMenus.removeElementAt(i);
				break;
			}
		}


		// Add all remaining extra menus...

		for (int i=0;i < tempExtraMenus.size();i++) {
			mainMenuBar.add((Menu) tempExtraMenus.elementAt(i));
		}

		// Add Preferences... under the Tools menu
		toolsMenu.addSeparator();
		toolsMenu.add(preferencesMenu);

		// Add the Tools menus
		mainMenuBar.add(toolsMenu);

		// Put About...  under Help
		helpMenu.addSeparator();
		helpMenu.add(aboutMenu);

		// Add Help
		mainMenuBar.add(helpMenu);

//		System.out.println ("Making tool bar.");

		if (toolBar != null) {

			// Resize toolbar
			toolBar.toolBar.resize (toolBar.toolBar.preferredSize());
	
			// Resize to fix Windows 95
			toolBar.toolBar.resize (toolBar.toolBar.preferredSize());
	
			// Show toolbar
			toolBar.toolBar.show();
//			System.out.println("toolbar info, toolBar: "+toolBar);
//			System.out.println("toolbar.toolbar info, toolBar.toolBar: "+toolBar.toolBar);
		}

		return true;
	}

	public java.awt.MenuBar GetMenuBar () {
		return mainMenuBar;	
	}
	
	
	public FrIJDEBasicToolBar GetToolBar () {
		return toolBar;
	}

	
	public boolean Close() {
		for (int i=0; i< tools.size();i++) {
			if (!( ( (besiex.FrIJDE.AbstractClasses.FrIJDETool) tools.elementAt(i)).Close()) )
				return false;
		}
		return true;
	}



	public String[] GetToolNames () {
//		System.out.println("Getting tool names...");
		
		File  handleToGetToolDirectoryList;
		
		try {
			handleToGetToolDirectoryList = new File(toolDir);
		} catch (Exception e) {
			System.out.println("Problem getting tools list");
			return null;
		}

//		System.out.println(handleToGetToolDirectoryList);

		String dirList[] =  handleToGetToolDirectoryList.list();

//		System.out.println(dirList);

		Vector v = new Vector(4);

		String temp;

		for (int i=0;i<dirList.length;i++) {
			// All tools will end with ".class"

			if (dirList[i].endsWith(".class")) {
				// All tools will begin with "FrIJDETool"	
				
				if (dirList[i].substring(dirList[i].lastIndexOf(File.pathSeparatorChar)+1).startsWith("FrIJDETool"))
					v.addElement(dirList[i]);

//				System.out.println("Found: "+dirList[i]);
			}
		}

		String toReturn[] = new String[v.size()];
		
		String packagePreface = "besiex.FrIJDE.Tools.";
		String tempClassName;

		for (int i=0;i<v.size();i++) {
			tempClassName = (String) v.elementAt(i);
			tempClassName = tempClassName.substring(0,tempClassName.lastIndexOf(".class"));
			tempClassName = packagePreface.concat(tempClassName);
			toReturn[i] = tempClassName;

//			System.out.println("Found tool: "+tempClassName);
		}

//		System.out.println("Finished getting tools.");
//		System.out.println(toReturn);

		return toReturn;
	}


}
