/* @(#)FrIJDEToolCompileAlpha.java  1.07  2/27/96  Benjamin "Quincy" Cabell V (thethe@wpi.edu), Besiex Software.
 * 
 * Copyright (c) 1996 Besiex Software. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that credit is this copyright notice
 * appears in all copies.  
 *
 * Distributed under the terms of the GNU Library General Public License.
 * 
 * FrIJDE Homepage:
 * http://amber.wpi.edu/~thethe/Document/Besiex/Java/FrIJDE/
 */

package besiex.FrIJDE.Tools;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import besiex.FrIJDE.AbstractClasses.*;

import MightyButtonWithCallback;
import MightyRelativeLayout;
import awtExt.*;
import sysExt.*;
import java.io.*;
import java.util.*;
import PackerLayout;

public class FrIJDEToolCompileAlpha extends FrIJDETool {

	final String compilerExecutableName = "javac_g";
	String[] commandLineSwitches;
	public CompilingThread compilingThread;

	public FrIJDEToolCompileAlpha () {
//		System.out.println("FrIJDEToolCompileAlpha:: ");
	}
		
	public boolean Init (FrIJDEMainFrame theFrIJDEFrame) {
		SetFrIJDEMainFrame(theFrIJDEFrame);

		try {
			helpMenuItem = new awtExt.MenuItem ("Help for CompileAlpha",Callback.newRef(this,"Help"));
			aboutMenuItem = new awtExt.MenuItem ("About CompileAlpha...",Callback.newRef(this,"About"));
			preferencesMenuItem = new awtExt.MenuItem ("CompileAlpha...",Callback.newRef(this,"Preferences"));
			toolMenuItem = new awtExt.MenuItem ("Compile!",Callback.newRef(this,"CompileDocument"));

			// Set up the tool bar items
			MightyButtonWithCallback compileDocButton = new MightyButtonWithCallback(GetFrIJDEMainFrame().baseDir.concat("Tools/Images/compile_doc"), 
					null,MightyButtonWithCallback.MOMENTARY);

			compileDocButton.addActionCallback(awtExt.Callback.newRef(this,"CompileDocument"));

			toolBarButtons=new Component[1];
			toolBarButtons[0] = compileDocButton;
	
		} catch (Exception e) {
			System.out.println("Hell fire.");
			return false;
		}


		// Set command line switches

		commandLineSwitches = new String[1];
		commandLineSwitches[0] = "-verbose";


		return true;
	}


    public void CompileDocument (awtExt.CallbackInfo theCBI) {
		String currentEditorFile = GetFrIJDEMainFrame().GetCurrentEditorFile();
		String compileCommandLine = compilerExecutableName + " ";
		
		for (int i=0; i < commandLineSwitches.length;i++)
			compileCommandLine += commandLineSwitches[i] +" ";
			
		compileCommandLine += currentEditorFile;

		compilingThread = new CompilingThread(this, compileCommandLine);
	}


	public boolean Close() {
		return true;
	}
}

class CompilingThread extends FrIJDEProcessRunnerForTool {
	CompilingDialog compileDialog;
	String[] compilerErrorLines=null;


	public CompilingThread(FrIJDETool theParent, String theCommandLine) {
		super (theParent,theCommandLine);
	}

	public String ProcessLineOutputHandler (String theProcessOutputAsString) {
		// Every line that is generated from the process is sent here.
		// Any responses to the line generated is returned via the return mechanism.

		// 
		if (theProcessOutputAsString.charAt(0)=='[') {
			// The output line is [parsed..., [loaded..., [checking..., [wrote..., or [done...
			
			// Trim the '['
			theProcessOutputAsString = theProcessOutputAsString.substring(1);
			
			StringTokenizer st = new StringTokenizer(theProcessOutputAsString);

			// Get the message type...
			String messageType = st.nextToken();
			String timeForCompletion;
			String className;

			if (messageType.equals("done")) {
				// There is no class name in the output message, but there is a time
				// This includes [done...

				className = null;

				st.nextToken(); // skip the word "in"
				timeForCompletion = st.nextToken();
				timeForCompletion = timeForCompletion.substring(0,(timeForCompletion.length()-1)); // strip the final ']'
			} else
				if (messageType.equals("checking")) {
					// There is a class name, preceeded by the word "class" in the output message, no time
					// This includes [checking...

					st.nextToken(); // skip the word "class"
					className = st.nextToken();
					className = className.substring(0,(className.length()-1)); // strip the final ']'
					timeForCompletion = null;
					compileDialog.currentClassCompiling.setText(className);
				} else 
					if (messageType.equals("wrote")) {
						// There is a class name in the output message, no time
						// This includes [wrote...

						className = st.nextToken();
						className = className.substring(0,(className.length()-1)); // strip the final ']'
						timeForCompletion = null;

						compileDialog.classesWritten.appendText(className+"\n");
					} else {
						// There should be a class name and a time in the output message
						// This includes [parsed... and [loaded...
						className = st.nextToken();

						st.nextToken(); // skip the word "in"
						timeForCompletion = st.nextToken();
						timeForCompletion = timeForCompletion.substring(0,(timeForCompletion.length()-1)); // strip the final ']'
				
						if (messageType.equals("parsed")) {
							compileDialog.currentClassCompiling.setText(className);
						} else
							if (messageType.equals("loaded")) {
								compileDialog.classesLoaded.appendText(className+"\n");
							}

					}
		} else {
			// The output line is an error or a compiler exception or unknown...
			//compileDialog.errorsFound.appendText(theProcessOutputAsString+"\n");


			// Two common error message types:

				// TYPE 1: Three lines of error info
				
					// First line: 
					// ClassNameWithPath:LineNumberOfError: ErrorMessage
				
					// Second line:
					// Text of source code line with error

					// Third line:
					// Blank spaces, then ^ to indicate exact position of error

				// TYPE 2: One line indicating the number of errors.
		
					// "1 error" or "XXX errors"

					// For the moment, ignore this type.


			if (compilerErrorLines == null) {

				// Handle the first type of error message...  the 3 line source error.

				if (IsFirstLineOfErrorInSource(theProcessOutputAsString)) {
					compilerErrorLines = new String[1];
					compilerErrorLines[0] = new String(theProcessOutputAsString);
				} else {

					// Handle other type of error message...

				}
			} else {
				// Handling another line in the compiler source error message...

				String[] temp = new String[compilerErrorLines.length+1];

				for (int i=0;i < compilerErrorLines.length;i++) {
					temp[i] = new String(compilerErrorLines[i]);
				}

				temp[compilerErrorLines.length] = new String(theProcessOutputAsString);

				if (temp.length == 3) {
					CompileErrorInfo errorInfo = CompileErrorProcess(temp);

					compileDialog.errorsFound.appendText(errorInfo.classNameWithPath+" "+errorInfo.lineNumber+ " " +
							errorInfo.caretPosition + " " + errorInfo.errorMessage+"\n");
		
					compilerErrorLines = null;
				} else {
					compilerErrorLines = temp;
				}
			}


		}

		return (null);
	}


	public boolean IsFirstLineOfErrorInSource (String theStringToCheck) {
		// First line: 
		// ClassNameWithPath:LineNumberOfError: ErrorMessage
		
		int firstSpacePosition = theStringToCheck.indexOf(" ");

		if (firstSpacePosition == -1)
			return false;

		// Break off the first chunk of info which has the ClassNameWithPath and LineNumberOfError

		String firstChunk = theStringToCheck.substring(0,firstSpacePosition-1);
		
		// Break off the error message
		String errorMessage = theStringToCheck.substring(firstSpacePosition+1);

		// Pick off the line number from the firstChunk
		
		int colonPos = firstChunk.lastIndexOf(":");

		if (colonPos == -1)
			return false;

		String lineNumberAsString = firstChunk.substring(colonPos+1);

		int lineNumber;

		try {
			lineNumber = (new Integer(lineNumberAsString)).intValue();
		} catch (NumberFormatException e) {
			return false;
		}

		return true;
	}


	public CompileErrorInfo CompileErrorProcess (String[] theErrorLines) {
		
		// First line: 
		// ClassNameWithPath:LineNumberOfError: ErrorMessage
		
		int firstSpacePosition = theErrorLines[0].indexOf(" ");

		// Break off the first chunk of info which has the ClassNameWithPath and LineNumberOfError

		String firstChunk = theErrorLines[0].substring(0,firstSpacePosition-1);
		
		// Break off the error message
		String errorMessage = theErrorLines[0].substring(firstSpacePosition+1);

		// Pick off the line number from the firstChunk
		
		int colonPos = firstChunk.lastIndexOf(":");

		String lineNumberAsString = firstChunk.substring(colonPos+1);

		int lineNumber = (new Integer(lineNumberAsString)).intValue();

		String classNameWithPath = firstChunk.substring(0,colonPos);

		// Second line:
		// Text of source code line with error

		// Nothing in the second line to bother with.


		// Third line:
		// Blank spaces, then ^ to indicate exact position of error

		int caretPos = 0;

		while (theErrorLines[2].charAt(caretPos) != '^') {
			caretPos++;
		}

		return (new CompileErrorInfo (classNameWithPath, errorMessage, lineNumber, caretPos));
	}


	public void ProcessStarted () {
		compileDialog = new CompilingDialog(parent);
	}

	public void ProcessEnded () {
		compileDialog.button.enable();
	}

}




class CompileErrorInfo {
	public String classNameWithPath;
	public String errorMessage;
	public int lineNumber;
	public int caretPosition;

	public CompileErrorInfo (String theClassNameWithPath, String theErrorMessage, int theLineNumber, int theCaretPosition) {
		classNameWithPath = theClassNameWithPath;
		errorMessage = theErrorMessage;
		lineNumber = theLineNumber;
		caretPosition = theCaretPosition;
	}
}





class ErrorTextArea extends java.awt.TextArea {
	public ErrorTextArea (FrIJDETool theParent,int theRows,int theColumns) {
		super(theRows,theColumns);
	}
}



class CompilingDialog extends FrIJDEDialogWindow {

	CompilingThread parent;
	FrIJDETool parentTool;

	public java.awt.TextField currentClassCompiling;
	public java.awt.TextArea classesLoaded;
	public java.awt.TextArea classesWritten;
	public ErrorTextArea errorsFound;
	
	java.awt.Button button;

	Panel compilingPanel;
	Panel loadedPanel;
	Panel wrotePanel;
	Panel errorPanel;

	final int numTextCols = 80;

    public CompilingDialog(FrIJDETool theParent) {
        super(theParent.frijdeMainFrame, "Compiling", true);
        parentTool = theParent;
		
		setLayout(new MightyRelativeLayout());

        setBackground(Color.lightGray);


	
		compilingPanel = new Panel();
		compilingPanel.setLayout(new MightyRelativeLayout());
		compilingPanel.add("label;relative to=none;placement=base",new Label("Compiling"));

		loadedPanel = new Panel();
		loadedPanel.setLayout(new MightyRelativeLayout());
		loadedPanel.add("label;relative to=none;placement=base",new Label("Loaded"));

		wrotePanel = new Panel();
		wrotePanel.setLayout(new MightyRelativeLayout());
		wrotePanel.add("label;relative to=none;placement=base",new Label("Wrote"));

		errorPanel = new Panel();
		errorPanel.setLayout(new MightyRelativeLayout());
		errorPanel.add("label;relative to=none;placement=base",new Label("Errors"));

		currentClassCompiling = new java.awt.TextField(numTextCols);
		compilingPanel.add("display;relative to=label;placement=below left",currentClassCompiling);

		classesLoaded = new java.awt.TextArea(3,numTextCols);
		loadedPanel.add("display;relative to=label;placement=below left",classesLoaded);

		classesWritten = new java.awt.TextArea (3,numTextCols);
		wrotePanel.add("display;relative to=label;placement=below left",classesWritten);

		errorsFound = new ErrorTextArea(parentTool,5,numTextCols);
		errorPanel.add("display;relative to=label;placement=below left",errorsFound);

		add("compilingPanel;relative to=none;placement=base",compilingPanel);
		add("loadedPanel;relative to=compilingPanel;placement=below",loadedPanel);
		add("wrotePanel;relative to=loadedPanel;placement=below",wrotePanel);
		add("errorPanel;relative to=wrotePanel;placement=below",errorPanel);

		button = new java.awt.Button("Ok");
		button.disable();

		add("button;relative to=errorPanel;placement=below",button);

		Dimension windowDimension;
		windowDimension = getLayout().preferredLayoutSize(this);
		windowDimension = getLayout().preferredLayoutSize(this);
	
		Dimension frameDimension = getParent().getLayout().preferredLayoutSize(this);
		frameDimension = getParent().getLayout().preferredLayoutSize(this);

        Dimension desktopDimension = Toolkit.getDefaultToolkit().getScreenSize();
		desktopDimension = Toolkit.getDefaultToolkit().getScreenSize();
 		
 		reshape((desktopDimension.width-frameDimension.width)/2, (desktopDimension.height-frameDimension.height)/2,
				windowDimension.width,windowDimension.height);
    }


	public boolean action(Event e,Object o) {

		if (e.target instanceof java.awt.Button)
			if (((java.awt.Button) e.target).getLabel().equals("Ok")) {
				// [Ok] clicked
				panelFrame.dispose();
				return true;
			} 

		return false;
	}

}


class FrIJDEDialogWindow extends java.awt.Panel {

	public FrIJDEDialogFrame panelFrame = null;

	/**
	Constructs the FrIJDEToolBarFrame that will hold this FrIJDEToolBarWindow, show the frame,
	and add this FrIJDEToolBarWindow. <p>
	*/

	public FrIJDEDialogWindow (FrIJDEMainFrame theFrIJDEMainFrame,String theTitle,boolean theModalityBoolean) {
	
		panelFrame = new FrIJDEDialogFrame(theFrIJDEMainFrame,theTitle,theModalityBoolean);
		show();
		panelFrame.add(this);
	}


	/**
	Show the frame which contains this panel. <p>
	*/

	public void show() {
		panelFrame.show();
	}


	/**
	Hide the frame which containes this panel. <p>
	*/

	public void hide() {
		panelFrame.hide();
	}

	/**
	Reshapes the FrIJDEDialogWindow, making sure it is clear of any of its parent insets.  Since the FrIJDEDialogFrame's
	size is defined as being just large enough to fit the FrIJDEDialogWindow and its own insets, the FrIJDEDialogFrame 
	needs to be reshaped as just described. <p>

	*/

	public synchronized void reshape(int x, int y, int width, int height) {
		super.reshape(panelFrame.insets().left,panelFrame.insets().top,width,height);
	
		panelFrame.reshape(panelFrame.location().x,panelFrame.location().y,
				width+panelFrame.insets().left+panelFrame.insets().right,
				height+panelFrame.insets().top+panelFrame.insets().bottom);

	}


	/**
	Returns the preferred size of this FrIJDEDialogWindow. <p>

	*@return The dimension of a rectangle which contains all the FrIJDEDialogWindow's components,
	 in accordance with the layout manager it uses.
	*/

	public Dimension preferredSize () {
		return (getLayout().preferredLayoutSize(this));
	}

	public Dimension minimumSize () {
		return (preferredSize());
	}

}


/**
This is the class which FrIJDEBasicToolBarWindow uses to construct the actual framed window object.  
It is a dialog, which is essentially a frame which can be made modal or modeless.  In this case, the only behavior this 
tool bar window must handle on its own is the request to destroy itself.  The tool bar window need never actually
destroy itself until FrIJDE is finished, so rather than destroy the tool bar, it is instead simply hidden. <p>

<b>Note:</b> This is not an abstract class!  It is a supporting class of an abstract class.<p>

@version 1.00,  21 February 1996

<p>

<b>Changes from last version</b>

<ul>
 	<li> No last version.
</ul>
 
@author <A HREF="http://amber.wpi.edu/~thethe">Benjamin "Quincy" Cabell V</A>
@author <A HREF="http://amber.wpi.edu/~thethe/Documents/Besiex/Java/index.html">Besiex Software</A>
*/


class FrIJDEDialogFrame extends java.awt.Dialog {


	public FrIJDEDialogFrame (FrIJDEMainFrame theFrIJDEMainFrame,String theTitle,boolean theModalBoolean) {
		super(theFrIJDEMainFrame,theTitle,theModalBoolean);
	}

	/**
	Destroys the FrIJDEDialogFrame upon request.  All other requests are passed
	along to the superclass handler. <p>
	
	*@return True if the event was handled and need not be passed down the handling chain, false otherwise.
	*/

	public boolean handleEvent(Event e) {

		if (e.id == Event.WINDOW_DESTROY) {
			dispose();
			return true;
		}

		return super.handleEvent(e);
	}
}
