/* @(#)FrIJDEToolDocumentMangerAlpha.java  1.05  2/27/96  Benjamin "Quincy" Cabell V (thethe@wpi.edu), Besiex Software.
 * 
 * Copyright (c) 1996 Besiex Software. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that credit is this copyright notice
 * appears in all copies.  
 *
 * Distributed under the terms of the GNU Library General Public License.
 * 
 * FrIJDE Homepage:
 * http://amber.wpi.edu/~thethe/Document/Besiex/Java/FrIJDE/
 */

package besiex.FrIJDE.Tools;

import java.awt.*;
import awtExt.*;
import sysExt.*;
import besiex.FrIJDE.AbstractClasses.*;
import java.util.Vector;
import java.io.*;
import MightyButtonWithCallback;

// This class should be a multiple document interface that is responsible for all the editor files
// in FrIJDE.  The ProjectManager can make requests of this class to load certain files.
// Further, the FrIDJEToolCompileInterface will be able to goto lines.


public class FrIJDEToolDocumentManagerAlpha extends FrIJDEDocumentManager {
	FrIJDEEditorAlpha editor;
	
	public FrIJDEToolDocumentManagerAlpha () {
	}

	
	public boolean Init (FrIJDEMainFrame theFrIJDEMainFrame) {
		SetFrIJDEMainFrame(theFrIJDEMainFrame);

		editor = new FrIJDEEditorAlpha(GetFrIJDEMainFrame());

		try {
			helpMenuItem = new awtExt.MenuItem ("Help for DocumentAlpha Editor",Callback.newRef(this,"Help"));
			aboutMenuItem = new awtExt.MenuItem ("About DocumentAlpha Editor...",Callback.newRef(this,"About"));
			toolMenuItem = null; // None
			preferencesMenuItem = new awtExt.MenuItem ("DocumentAlpha Editor...",Callback.newRef(this,"Preferences"));


			// This editor needs two menus on the main menu bar: File menu and Edit menu
			menusOnMainMenuBar = new awtExt.Menu[2];

			// File menu
			menusOnMainMenuBar[0]=new awtExt.Menu("File");
			menusOnMainMenuBar[0].add(new awtExt.MenuItem("New",Callback.newRef(this,"NewDocument")));
			menusOnMainMenuBar[0].add(new awtExt.MenuItem("Open...",Callback.newRef(this,"OpenDocument")));
			menusOnMainMenuBar[0].add(new awtExt.MenuItem("Close",Callback.newRef(this,"CloseDocument")));
			menusOnMainMenuBar[0].add(new awtExt.MenuItem("Save",Callback.newRef(this,"SaveDocument")));
			menusOnMainMenuBar[0].add(new awtExt.MenuItem("Save as",Callback.newRef(this,"SaveAsDocument")));
			menusOnMainMenuBar[0].add(new java.awt.MenuItem("-"));
			menusOnMainMenuBar[0].add(new awtExt.MenuItem("Exit",Callback.newRef(this,"Exit")));

			// Edit menu
			menusOnMainMenuBar[1]=new awtExt.Menu("Edit");
			menusOnMainMenuBar[1].add(new awtExt.MenuItem("Cut",Callback.newRef(this,"CutInDocument")));
			menusOnMainMenuBar[1].add(new awtExt.MenuItem("Copy",Callback.newRef(this,"CopyInDocument")));
			menusOnMainMenuBar[1].add(new awtExt.MenuItem("Paste",Callback.newRef(this,"PasteInDocument")));
			menusOnMainMenuBar[1].add(new java.awt.MenuItem("-"));
			menusOnMainMenuBar[1].add(new awtExt.MenuItem("Find...",Callback.newRef(this,"FindInDocument")));
			menusOnMainMenuBar[1].add(new awtExt.MenuItem("Find again",Callback.newRef(this,"FindAgainInDocument")));
			menusOnMainMenuBar[1].add(new awtExt.MenuItem("Replace...",Callback.newRef(this,"ReplaceInDocument")));
			menusOnMainMenuBar[1].add(new awtExt.MenuItem("Go to line...",Callback.newRef(this,"GoToLineInDocument")));
			menusOnMainMenuBar[1].add(new java.awt.MenuItem("-"));
			menusOnMainMenuBar[1].add(new awtExt.MenuItem("Select all",Callback.newRef(this,"SelectAllInDocument")));


			// Set up the tool bar items
			MightyButtonWithCallback searchButton = new MightyButtonWithCallback(GetFrIJDEMainFrame().baseDir.concat("Tools/Images/find"), 
					null,MightyButtonWithCallback.MOMENTARY);

			MightyButtonWithCallback saveButton = new MightyButtonWithCallback(GetFrIJDEMainFrame().baseDir.concat("Tools/Images/save_doc"), 
					null,MightyButtonWithCallback.MOMENTARY);

			MightyButtonWithCallback openButton = new MightyButtonWithCallback(GetFrIJDEMainFrame().baseDir.concat("Tools/Images/open_doc"), 
					null,MightyButtonWithCallback.MOMENTARY);

			MightyButtonWithCallback newButton = new MightyButtonWithCallback(GetFrIJDEMainFrame().baseDir.concat("Tools/Images/new_doc"), 
					null,MightyButtonWithCallback.MOMENTARY);

			try {
				searchButton.addActionCallback(awtExt.Callback.newRef(this,"FindInDocument"));
				saveButton.addActionCallback(awtExt.Callback.newRef(this,"SaveDocument"));
				openButton.addActionCallback(awtExt.Callback.newRef(this,"OpenDocument"));
				newButton.addActionCallback(awtExt.Callback.newRef(this,"NewDocument"));
			} catch (Exception e) {
				System.out.println ("Damn exception.");
			}

			toolBarButtons=new Component[4];
			toolBarButtons[0] = searchButton;
			toolBarButtons[1] = saveButton;
			toolBarButtons[2] = openButton;
			toolBarButtons[3] = newButton;

	
		} catch (Exception e) {
			System.out.println("Hell fire.");
			return false;
		}

		return true;
	}



	public boolean OpenDocument (String theFileNameWithPath) {
		return false;
	}


	public boolean CloseDocument (String theFileNameWithPath) {
		return false;	
	}

	public boolean CloseAllDocuments () {
		return false;	
	}

	public boolean NewDocument () {
		editor.NewDocument();
		return true;
	}

	public boolean NewDocumentWithFileNameWithPath (String theFileNameWithPath) {
		return false;
	}


	public boolean GotoLineInDocument (String theFileNameWithPath,int theLineNumber,int theCharacterPosition) {

		return false;
	}


	public boolean GotoLineInDocument (String theFileNameWithPath,int theLineNumber) {

		return false;
	}


	
	public boolean Close() {        // Closes the tool and its contents (if any), checks with user if
	                                // files need saving, etc.  Returns true if successful, false
                                    // if user aborts closing (when asked to save, not save, cancel if
                                    // files were still open).
		return true;
	}



	public void Help (CallbackInfo theCBI) {
		editor.showAboutDialog();
	}

	public void About (CallbackInfo theCBI) {
		editor.showAboutDialog();
	}

	public void Preferences (CallbackInfo theCBI) {

	}


	public void NewDocument (CallbackInfo theCBI) {
		NewDocument();
	}

	public void OpenDocument (CallbackInfo theCBI) {
		editor.NewDocument();
		editor.openFile();
	}

	public void CloseDocument (CallbackInfo theCBI) {
	
	}

	public void SaveDocument (CallbackInfo theCBI) {
		if (editor.documents.size() != 0) 
			editor.saveOpenedFile();
	}

	public void SaveAsDocument (CallbackInfo theCBI) {
		if (editor.documents.size() != 0) 
			editor.saveAsFile();
	}


	public void Exit (CallbackInfo theCBI) {
	
	}


	public void CutInDocument (CallbackInfo theCBI) {
		if (editor.documents.size() != 0) 
			editor.deleteText();
	}

	public void CopyInDocument (CallbackInfo theCBI) {
		if (editor.documents.size() != 0) 
			editor.copy();
	}

	public void PasteInDocument (CallbackInfo theCBI) {
		if (editor.documents.size() != 0) 
			editor.paste();
	}

	public void SelectAllInDocument (CallbackInfo theCBI) {
	
	}

	public void FindInDocument (CallbackInfo theCBI) {
		if (editor.documents.size() != 0) 
			editor.showFindDialog();
	}

	public void FindAgainInDocument (CallbackInfo theCBI) {
		if (editor.documents.size() != 0) 
			editor.findSelectedText();
	}

	public void ReplaceInDocument (CallbackInfo theCBI) {
		
	}

	public void GoToLineInDocument (CallbackInfo theCBI) {
		
	}

}


//______________________________________________________________
//______________________________________________________________
class FrIJDEEditorAlpha {

	Vector documents = new Vector(4);
	int currentDocument=-1;
	FrIJDEMainFrame frijdeMainFrame = null;

    public FileDialog openDialog, saveDialog;

    public HelpDialog helpDialog = null;
    public AboutDialog aboutDialog = null;
    public ReplaceDialog replaceDialog = null;
    public FindDialog findDialog = null;
    public ErrorDialog errorDialog = null;

    public FrIJDEEditorAlpha(FrIJDEMainFrame theMainFrame) {
		currentDocument = 0;
		frijdeMainFrame = theMainFrame;
		CreateDialogs();
    }


    private void CreateDocument(Dimension theDimension) {
		currentDocument = documents.size();
		documents.addElement(new FrIJDEDocumentAlpha(this,theDimension));
    }

    private void CreateDialogs() {
        openDialog = new FileDialog(frijdeMainFrame, "Open File",FileDialog.LOAD);
        saveDialog = new FileDialog(frijdeMainFrame, "Save File",FileDialog.SAVE);
    }


	public void NewDocument () {
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		CreateDocument(d);
		((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
		frijdeMainFrame.SetCurrentEditorFile(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName);
	}

	public void CloseDocument () {
		// Check to see if user wants to save data, or cancel close...
		
		// Destroy the current document
		((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).dispose();
		documents.removeElementAt(currentDocument);
		currentDocument = documents.size();

	}


    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                System.exit(0);
/*
            case Event.ACTION_EVENT:
                if(evt.target instanceof MenuItem) {
                    if(evt.target == openMenuItem) openFile();
                    else if(evt.target == saveAsMenuItem) saveAsFile();
                    else if(evt.target == aboutMenuItem) showAboutDialog();
                    else if(evt.target == newMenuItem) startNewText();
                    else if(evt.target == saveMenuItem) saveOpenedFile();
                    else if(evt.target == exitMenuItem) System.exit(0);
                    else if(evt.target == helpMenuItem)	showHelpDialog();
                    else if(evt.target == findMenuItem) findSelectedText();
                    else if(evt.target == findPopMenuItem) showFindDialog();
                    else if(evt.target == deleteMenuItem) deleteText();
                    else if(evt.target == replaceMenuItem) replaceSelectText();
                    else if(evt.target == replacePopMenuItem) showRepDialog();
                    else if(evt.target == replaceAllMenuItem) replaceAll();
                    else if(evt.target == buttonsMenuItem) showButtons();
                    else if(evt.target == copyMenuItem) copy();
                    else if(evt.target == pasteMenuItem) paste();
                    else if(evt.target == buttonsMenuItem) showButtons();
                    else System.out.println("Internal program error #1!");
                }
                return(true);
*/
            case Event.KEY_ACTION:
                if (evt.key == Event.F2) findSelectedText();
                else if (evt.key == Event.F3) showFindDialog();
                else if (evt.key == Event.F4) deleteText();
                else if (evt.key == Event.F5) replaceSelectText();
                else if (evt.key == Event.F6) showRepDialog();
                else if (evt.key == Event.F7) replaceAll();
                else if (evt.key == Event.F9) saveOpenedFile();
        }
        return(false);
    }

    public void copy() {
		((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).copyString = 
				((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectedText();
		
		((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
		frijdeMainFrame.SetCurrentEditorFile(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName);
    }

    public void paste() {
        if (((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).copyString.length() > 0)
            ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.insertText(
					((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).copyString,
					((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectionStart());

        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
		frijdeMainFrame.SetCurrentEditorFile(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName);
    }

    // Read in an existing file
    public void openFile() {
        String nameOfFileToOpen;
		String directoryOfFileToOpen;

        openDialog.show();

        nameOfFileToOpen = openDialog.getFile();
 		directoryOfFileToOpen = openDialog.getDirectory();
 
 		if (nameOfFileToOpen != null) {
            nameOfFileToOpen = check(nameOfFileToOpen);
            
			if (read(nameOfFileToOpen))
				((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName = directoryOfFileToOpen +
						nameOfFileToOpen;
        }

        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).setTitle(nameOfFileToOpen);
        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
		frijdeMainFrame.SetCurrentEditorFile(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName);
    }


    // Save text to new or existing file
    public void saveAsFile() {
        String nameOfFileToSave;
		String directoryOfFileToSave;

        saveDialog.show();
        nameOfFileToSave = saveDialog.getFile();
		directoryOfFileToSave = saveDialog.getDirectory();

        if (nameOfFileToSave != null) {
            nameOfFileToSave = check(nameOfFileToSave);

            if (write(nameOfFileToSave))
				((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName = directoryOfFileToSave +
					nameOfFileToSave;
        }

        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).setTitle(nameOfFileToSave);
        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
		frijdeMainFrame.SetCurrentEditorFile(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName);
    }


    // Save text to already opened file
    public void saveOpenedFile() {
        if (((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName == null) {
            showErrorDialog("You must specify a filename");
        } else {
            write(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName);
            ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
			frijdeMainFrame.SetCurrentEditorFile(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName);
        }
    }

    public void startNewText() {
        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName = null;
        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.setText("");
        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
		frijdeMainFrame.SetCurrentEditorFile(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName);
    }

    public void showAboutDialog() {
        if (aboutDialog != null) 
			aboutDialog.dispose();

        aboutDialog = new AboutDialog(this);
        aboutDialog.show();
    }

    public void showHelpDialog() {
        if (helpDialog != null) 
			helpDialog.dispose();

        helpDialog = new HelpDialog(this);
        helpDialog.show();
    }

    public void showFindDialog() {
        if (findDialog != null) 
			findDialog.dispose();

        String sel = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectedText();

        if (sel.length() > 0) 
			((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString = sel;

        findDialog = new FindDialog(this, ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString);
        findDialog.show();
        findDialog.setFocus();
    }

    public void showRepDialog() {
        if (replaceDialog != null) 
			replaceDialog.dispose();
        
		String sel = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectedText();
        
		if (sel.length() > 0) 
			((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString = sel;
        
		replaceDialog = new ReplaceDialog(this, ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString,
				((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).replaceString);
        
		replaceDialog.show();
        replaceDialog.setFocus();
    }


    public void showErrorDialog(String message) {
        if (errorDialog != null) 
			errorDialog.dispose();

        errorDialog = new ErrorDialog(this, message);
        errorDialog.show();
    }

    private boolean read(String theFileName) {

        String line;
        FileInputStream in = null;
        DataInputStream dataIn = null;
        BufferedInputStream bis = null;
        StringBuffer buffer = new StringBuffer();

        try {
            in = new FileInputStream(theFileName);
            bis = new BufferedInputStream(in);
            dataIn = new DataInputStream(bis);
        } catch(Throwable e) {
            showErrorDialog("Can't open \""+theFileName+"\"");
            return(false);
        }

        try {
            while ((line = dataIn.readLine()) != null) {
                buffer.append(line + "\n");
            }

            in.close();
            ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.setText(buffer.toString());
        } catch(IOException e) {
            showErrorDialog("Can't read \""+theFileName+"\"");
            return(false);
        }

        return(true);
    }


    private boolean write(String theFileName) {

        FileOutputStream os = null;

        try {
            os = new FileOutputStream(theFileName);
        } catch (Throwable e) {
            showErrorDialog("Can't open \""+theFileName+"\"");
            return(false);
        }

        try {
            String s = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getText();
            int len = s.length();
            for (int i=0; i<len; i++) {
               os.write(s.charAt(i));
            }
            os.close();
        } catch(IOException e) {
            showErrorDialog("Can't write \""+theFileName+"\"");
            return(false);
        }

        return(true);
    }

    // Compensate for dialog bug
    private String check(String theFileName) {
        if (theFileName.endsWith(".*.*")) {
            theFileName = theFileName.substring(0, theFileName.length()-4);
        }

        return(theFileName);
    }

    public void setFindString(String str) {
    	((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString = str;
    }

    public void setReplaceString(String str) {
        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).replaceString = str;
    }

    public void findSelectedText() {
        String sel = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectedText();
        
		if (sel.length() > 0) 
			((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString = sel;
        
		findText();
    }

    public void findText() {

        String s;
        int spoint, index;

        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
        
		if (((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString.length() == 0) 
			return;

        s = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getText();
        
		if (s.length() == 0)
			return;

        spoint = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectionEnd();
        index = s.substring(spoint).indexOf(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString);
        
		if (index >= 0) {
            int i = spoint + index;
            ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.select(i, i + 
					((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString.length());
        }
    }

    public void replaceSelectText() {
        String sel = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectedText();
        if (sel.length() > 0) 
			((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString = sel;
        replaceText();
    }

    public boolean replaceText() {
        String s;
        int spoint, index;

        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
        if (((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString.length() == 0)
			return(false);

        s = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getText();
        
		if (s.length() == 0) 
			return(false);

        spoint = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectionEnd();
        index = s.substring(spoint).indexOf(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString);
        
		if (index >= 0) {
            int i = spoint + index;
            int j = i + ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString.length();
            
			((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.replaceText(
					((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).replaceString, i, j);
            
			((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.select(i, 
					i+((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).replaceString.length());
            
			return(true);
        }
        return(false);
    }

    public void replaceAll() {
        String sel = ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectedText();
        if (sel.length() > 0) 
			((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).findString = sel;

        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.select(0, 0);
        
		while (replaceText()) ;
    }

    public void deleteText() {
        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.replaceText("", 
				((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectionStart(),
				((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.getSelectionEnd());

        ((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).textArea.requestFocus();
		frijdeMainFrame.SetCurrentEditorFile(((FrIJDEDocumentAlpha) documents.elementAt(currentDocument)).fileName);
    }

    
} // End of MAIN CLASS



class FrIJDEDocumentAlpha extends java.awt.Dialog {
	public java.awt.TextArea textArea;
    
	public String findString = "";
	public String copyString = "";
    public String replaceString = "";

    public String fileName = null;

	FrIJDEEditorAlpha parent = null;

	public FrIJDEDocumentAlpha (FrIJDEEditorAlpha theParent, Dimension theDimension) {
		super(theParent.frijdeMainFrame,"",false);

		parent = theParent;

        setBackground(Color.gray);
        setFont(new Font("TimesRoman", Font.PLAIN, 12));

        textArea = new java.awt.TextArea(24, 80);
        textArea.setEditable(true);
        add("Center", textArea);

		Rectangle mainFrameBounds = parent.frijdeMainFrame.bounds();
        Insets insets = parent.frijdeMainFrame.insets();

		reshape (mainFrameBounds.x+insets.left,mainFrameBounds.y+insets.top,
				mainFrameBounds.width-(insets.left+insets.right),mainFrameBounds.height-(insets.top+insets.bottom));

		//resize(theDimension.width, theDimension.height);
		show();
    }


    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY: 
                parent.CloseDocument();
				return true;
		}
		return false;
	}

}




//______________________________________________________________
//______________________________________________________________
class HelpDialog extends Dialog {

    FrIJDEEditorAlpha parent;

    public HelpDialog(FrIJDEEditorAlpha parent) {
        super(null, "Help Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;

        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
//		d = parent.size();

        int WIDTH = 500;
        int HEIGHT = 200;

        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                return(true);
        }
        return(false);
    }

    public void paint(Graphics g) {
        Dimension d;
        d = size();

        g.setColor(Color.black);
        int x[] = new int[50];
        int y[] = new int[50];
        for (int i=0; i<49; i++) {
            x[i] = (int)((d.width-20) * Math.random() + 10);
            y[i] = (int)((d.height-20) * Math.random() + 10);
        }
        x[49] = x[0];
        y[49] = y[0];
        Polygon p = new Polygon(x, y, 50);
        g.fillPolygon(p);

        g.setColor(Color.yellow);
        g.setFont(new Font("TimesRoman", Font.PLAIN, 25));
        g.drawString("Hold down the shift key while using", 10,d.height/5);
        g.drawString("the arrow keys to select text.", 10,2*d.height/5);
        g.drawString("PS: Try selecting help again.", 10,4*d.height/5);
    }
}

//______________________________________________________________
//______________________________________________________________
class AboutDialog extends Dialog {

    FrIJDEEditorAlpha parent;

    public AboutDialog(FrIJDEEditorAlpha parent) {

        super(null, "About Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;

        Panel p;
        p = new Panel();
        p.setBackground(Color.black);
        add("North", p);
        p = new Panel();
        p.setBackground(Color.black);
        add("South", p);
        p = new Panel();
        p.setBackground(Color.black);
        add("East", p);
        p = new Panel();
        p.setBackground(Color.black);
        add("West", p);

        p = new Panel();
        p.setLayout(new GridLayout(7, 1));
        p.add(new Label(""));
        p.add(new Label("Trivial Editor (FrIJDEEditorAlpha)"));
        p.add(new Label("An editor written in the Java language"));
        p.add(new Label("Copyright 1996 by Larry Landwehr " +
            "(bitsafe@execpc.com)"));
        p.add(new Label(""));
        p.add(new Label("This program took about 30 hours to write"));
        p.add(new Label(""));
        add("Center", p);

        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();

        int WIDTH = 400;
        int HEIGHT = 200;
        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                return(true);
        }
        return(false);
    }
}

//______________________________________________________________
//______________________________________________________________
class FindDialog extends Dialog {

    FrIJDEEditorAlpha parent;
    java.awt.TextField textField;

    public FindDialog(FrIJDEEditorAlpha parent, String text) {

        super(null, "Find Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;

        Panel p;
        Label l;
        int WIDTH = 300;
        int HEIGHT = 75;

        p = new Panel();
        p.setLayout(null);

        int height = 25, space = 10;
        int lwidth = 35, rmargin = 30;
        int y = HEIGHT / 2 - height;

        l = new Label("Find");
        l.reshape(0, y, lwidth, height);
        p.add(l);

        textField = new java.awt.TextField(text);
        int f = lwidth + space;
        textField.reshape(f, y, WIDTH-f-rmargin, height);
        p.add(textField);

        add("Center", p);

        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();

        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH, HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                return(true);
            case Event.ACTION_EVENT:
                if(evt.target == textField) {
                    dispose();
                    if (textField.getText().length() > 0) {
                        parent.setFindString(textField.getText());
                        parent.findText();
                        ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                        return(true);
                    }
                } else {
                    System.out.println("Internal program error #4!");
                    ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                    return(true);
                }
        }
        return(false);
    }

    public void setFocus() {
        textField.requestFocus();
        textField.select(0, textField.getText().length());
    }
}

//______________________________________________________________
//______________________________________________________________
class ReplaceDialog extends Dialog {

    FrIJDEEditorAlpha parent;
    java.awt.TextField fromField, toField;

    public ReplaceDialog(FrIJDEEditorAlpha parent, String fromString, String toString) {

        super(null, "Replace Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;

        Panel p;
        Label l;
        int WIDTH = 300;
        int HEIGHT = 100;

        p = new Panel();
        p.setLayout(null);

        int height = 25, space = 10;
        int lwidth = 50, rmargin = 30;
        int y = HEIGHT / 3 - height;

        l = new Label("Replace");
        l.reshape(0, y, lwidth, height);
        p.add(l);

        fromField = new java.awt.TextField(fromString);
        int f = lwidth + space;
        fromField.reshape(f, y, WIDTH-f-rmargin, height);
        p.add(fromField);

        y = 2 * HEIGHT / 3 - height;

        l = new Label("With");
        l.reshape(0, y, lwidth, height);
        p.add(l);

        toField = new java.awt.TextField(toString);
        f = lwidth + space;
        toField.reshape(f, y, WIDTH-f-rmargin, height);
        p.add(toField);

        add("Center", p);

        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();

        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                return(true);
            case Event.ACTION_EVENT:
                if(evt.target == fromField) {
                    toField.requestFocus();
                    return(true);
                } else if(evt.target == toField) {
                    dispose();
                    if (fromField.getText().length() > 0) {
                        parent.setFindString(fromField.getText());
                        parent.setReplaceString(toField.getText());
                        parent.replaceText();
                        ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                        return(true);
                    }
                } else {
                    System.out.println("Internal program error #5!");
                    ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                    return(true);
                }
        }
        return(false);
    }

    public void setFocus() {
        fromField.requestFocus();
        fromField.select(0, fromField.getText().length());
    }
}


//______________________________________________________________
//______________________________________________________________
class ErrorDialog extends Dialog {

    FrIJDEEditorAlpha parent;
    String message;

    public ErrorDialog(FrIJDEEditorAlpha parent, String message) {
        super(null, "Error Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;
        this.message = message;

        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        int WIDTH = 500;
        int HEIGHT = 130;
        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                return(true);
        }
        return(false);
    }

    public void paint(Graphics g) {
        Dimension d;
        d = size();

        g.setColor(Color.yellow);
        int x[] = new int[4];
        int y[] = new int[4];
        x[0] = 10; y[0] = 10;
        x[1] = d.width/3; y[1] = 3*d.height/4;
        x[2] = d.width-10; y[2] = 10;
        x[3] = 10; y[3] = 10;
        Polygon p = new Polygon(x, y, 4);
        g.fillPolygon(p);

        g.setColor(Color.black);
        g.setFont(new Font("TimesRoman", Font.PLAIN, 25));
        g.drawString(message, 10, d.height/2);
    }
}

/*
//______________________________________________________________
//______________________________________________________________
class SaveBeforeCloseDialog extends Dialog {

    FrIJDEEditorAlpha parent;

    public SaveBeforeCloseDialog(FrIJDEEditorAlpha parent) {

        super(null, "Save before close dialog...", true);
        setBackground(Color.lightGray);
        this.parent = parent;

        Panel p;
        p = new Panel();

        p.setLayout(new GridLayout(3, 1));
        p.add(new Label(""));
        p.add(new Label("Save "+((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).fileName+
			"before closing?");
		p.add(new Label(""));
        add("Center", p);

        Button buttonYes = new Button("Yes");
        Button buttonNo = new Button("No");

        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();

        int WIDTH = 400;
        int HEIGHT = 200;

        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
			
            case Event.WINDOW_DESTROY:
                dispose();
                ((FrIJDEDocumentAlpha) parent.documents.elementAt(parent.currentDocument)).textArea.requestFocus();
                return(true);
        }
        return(false);
    }
}
*/
