/* @(#)FrIJDEToolInterpretAlpha.java  1.01  2/27/96  Benjamin "Quincy" Cabell V (thethe@wpi.edu), Besiex Software.
 * 
 * Copyright (c) 1996 Besiex Software. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that credit is this copyright notice
 * appears in all copies.  
 *
 * Distributed under the terms of the GNU Library General Public License.
 * 
 * FrIJDE Homepage:
 * http://amber.wpi.edu/~thethe/Document/Besiex/Java/FrIJDE/
 */

package besiex.FrIJDE.Tools;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import besiex.FrIJDE.AbstractClasses.*;
import besiex.FrIJDE.System.*;

import MightyButtonWithCallback;
import MightyRelativeLayout;
import awtExt.*;
import sysExt.*;
import java.io.*;
import java.util.*;
import PackerLayout;

public class FrIJDEToolInterpretAlpha extends FrIJDETool {

	final String interpreterExecutableName = "java";
	String[] commandLineSwitches;
	public InterpretingThread interpretingThread;

	public FrIJDEToolInterpretAlpha () {

	}
		
	public boolean Init (FrIJDEMainFrame theFrIJDEFrame) {
		SetFrIJDEMainFrame(theFrIJDEFrame);

		try {
			helpMenuItem = new awtExt.MenuItem ("Help for InterpretAlpha",Callback.newRef(this,"Help"));
			aboutMenuItem = new awtExt.MenuItem ("About InterpretAlpha...",Callback.newRef(this,"About"));
			preferencesMenuItem = new awtExt.MenuItem ("InterpretAlpha...",Callback.newRef(this,"Preferences"));
			toolMenuItem = new awtExt.MenuItem ("Interpret!",Callback.newRef(this,"InterpretDocument"));

			// Set up the tool bar items
			MightyButtonWithCallback interpretDocButton = new MightyButtonWithCallback(GetFrIJDEMainFrame().baseDir.concat("Tools/Images/interpret_doc"), 
					null,MightyButtonWithCallback.MOMENTARY);

			interpretDocButton.addActionCallback(awtExt.Callback.newRef(this,"InterpretDocument"));

			toolBarButtons=new Component[1];
			toolBarButtons[0] = interpretDocButton;
	
		} catch (Exception e) {
			System.out.println("Hell fire.");
			return false;
		}

		return true;
	}


    public void InterpretDocument (awtExt.CallbackInfo theCBI) {
		String currentEditorFile = GetFrIJDEMainFrame().GetCurrentEditorFile();
		String interpretCommandLine = interpreterExecutableName;
		String classPath = System.getProperty("java.class.path");

		commandLineSwitches = new String[2];
		commandLineSwitches[0] = "-classpath";

		if (classPath.endsWith(java.io.File.pathSeparator))
			classPath += FrIJDEStringMethods.FilePathFromFileNameWithPath(currentEditorFile);
		else
			classPath += java.io.File.pathSeparator + FrIJDEStringMethods.FilePathFromFileNameWithPath(currentEditorFile);

		commandLineSwitches[1] = classPath;

		if (commandLineSwitches != null)
			for (int i=0; i < commandLineSwitches.length;i++)
				interpretCommandLine += " " + commandLineSwitches[i];
			
		interpretCommandLine += " " + FrIJDEStringMethods.FileNameFromFileNameWithPath(currentEditorFile);

		// Strip the .java extension
		interpretCommandLine = interpretCommandLine.substring(0,interpretCommandLine.lastIndexOf(".java"));

		interpretingThread = new InterpretingThread(this, interpretCommandLine);
	}


	public boolean Close() {
		return true;
	}
}

class InterpretingThread extends FrIJDEProcessRunnerForTool {
	InterpretingDialog interpreterDialog;

	public InterpretingThread(FrIJDETool theParent, String theCommandLine) {
		super (theParent,theCommandLine);
	}

	public String ProcessLineOutputHandler (String theProcessOutputAsString) {
		interpreterDialog.systemOut.appendText(theProcessOutputAsString+"\n");
		return (null);
	}

	public void ProcessStarted () {
		interpreterDialog = new InterpretingDialog(parent);
	}

	public void ProcessEnded () {
		interpreterDialog.button.enable();
	}
}





class InterpretingDialog extends FrIJDEDialogWindow {

	InterpretingThread parent;
	FrIJDETool parentTool;

	public java.awt.TextArea systemOut;
	
	java.awt.Button button;

	Panel systemOutPanel;

    public InterpretingDialog(FrIJDETool theParent) {
        super(theParent.frijdeMainFrame, "Running Java Interpreter", true);

        parentTool = theParent;
		
		setLayout(new MightyRelativeLayout());
        setBackground(Color.lightGray);

		systemOutPanel = new Panel();
		systemOutPanel.setLayout(new MightyRelativeLayout());
		systemOutPanel.add("label;relative to=none;placement=base",new Label("System.out"));
				
		systemOut = new java.awt.TextArea(20,80);
		systemOutPanel.add("display;relative to=label;placement=below left",systemOut);

		add("systemOutPanel;relative to=none;placement=base",systemOutPanel);

		button = new java.awt.Button("Ok");
		button.disable();
		add("button;relative to=systemOutPanel;placement=below",button);

		Dimension windowDimension;
		windowDimension = getLayout().preferredLayoutSize(this);
		windowDimension = getLayout().preferredLayoutSize(this);
	
		Dimension frameDimension = getParent().getLayout().preferredLayoutSize(this);
		frameDimension = getParent().getLayout().preferredLayoutSize(this);

        Dimension desktopDimension = Toolkit.getDefaultToolkit().getScreenSize();
		desktopDimension = Toolkit.getDefaultToolkit().getScreenSize();
 		
 		reshape((desktopDimension.width-frameDimension.width)/2, (desktopDimension.height-frameDimension.height)/2,
				windowDimension.width,windowDimension.height);
    }


	public boolean action(Event e,Object o) {

		if (e.target instanceof java.awt.Button)
			if (((java.awt.Button) e.target).getLabel().equals("Ok")) {
				// [Ok] clicked
				panelFrame.dispose();
				return true;
			} 

		return false;
	}

}


class FrIJDEDialogWindow extends java.awt.Panel {

	public FrIJDEDialogFrame panelFrame = null;

	/**
	Constructs the FrIJDEToolBarFrame that will hold this FrIJDEToolBarWindow, show the frame,
	and add this FrIJDEToolBarWindow. <p>
	*/

	public FrIJDEDialogWindow (FrIJDEMainFrame theFrIJDEMainFrame,String theTitle,boolean theModalityBoolean) {
	
		panelFrame = new FrIJDEDialogFrame(theFrIJDEMainFrame,theTitle,theModalityBoolean);
		show();
		panelFrame.add(this);
	}


	/**
	Show the frame which contains this panel. <p>
	*/

	public void show() {
		panelFrame.show();
	}


	/**
	Hide the frame which containes this panel. <p>
	*/

	public void hide() {
		panelFrame.hide();
	}

	/**
	Reshapes the FrIJDEDialogWindow, making sure it is clear of any of its parent insets.  Since the FrIJDEDialogFrame's
	size is defined as being just large enough to fit the FrIJDEDialogWindow and its own insets, the FrIJDEDialogFrame 
	needs to be reshaped as just described. <p>

	*/

	public synchronized void reshape(int x, int y, int width, int height) {
		super.reshape(panelFrame.insets().left,panelFrame.insets().top,width,height);
	
		panelFrame.reshape(panelFrame.location().x,panelFrame.location().y,
				width+panelFrame.insets().left+panelFrame.insets().right,
				height+panelFrame.insets().top+panelFrame.insets().bottom);

	}


	/**
	Returns the preferred size of this FrIJDEDialogWindow. <p>

	*@return The dimension of a rectangle which contains all the FrIJDEDialogWindow's components,
	 in accordance with the layout manager it uses.
	*/

	public Dimension preferredSize () {
		return (getLayout().preferredLayoutSize(this));
	}

	public Dimension minimumSize () {
		return (preferredSize());
	}

}


/**
This is the class which FrIJDEBasicToolBarWindow uses to construct the actual framed window object.  
It is a dialog, which is essentially a frame which can be made modal or modeless.  In this case, the only behavior this 
tool bar window must handle on its own is the request to destroy itself.  The tool bar window need never actually
destroy itself until FrIJDE is finished, so rather than destroy the tool bar, it is instead simply hidden. <p>

<b>Note:</b> This is not an abstract class!  It is a supporting class of an abstract class.<p>

@version 1.00,  21 February 1996

<p>

<b>Changes from last version</b>

<ul>
 	<li> No last version.
</ul>
 
@author <A HREF="http://amber.wpi.edu/~thethe">Benjamin "Quincy" Cabell V</A>
@author <A HREF="http://amber.wpi.edu/~thethe/Documents/Besiex/Java/index.html">Besiex Software</A>
*/


class FrIJDEDialogFrame extends java.awt.Dialog {


	public FrIJDEDialogFrame (FrIJDEMainFrame theFrIJDEMainFrame,String theTitle,boolean theModalBoolean) {
		super(theFrIJDEMainFrame,theTitle,theModalBoolean);
	}

	/**
	Destroys the FrIJDEDialogFrame upon request.  All other requests are passed
	along to the superclass handler. <p>
	
	*@return True if the event was handled and need not be passed down the handling chain, false otherwise.
	*/

	public boolean handleEvent(Event e) {

		if (e.id == Event.WINDOW_DESTROY) {
			dispose();
			return true;
		}

		return super.handleEvent(e);
	}
}
